SET QUOTED_IDENTIFIER ON
DECLARE @eSchoolDB sysname 
DECLARE @SqlCommand nvarchar(max)
DECLARE eSchoolDB_Cursor cursor LOCAL READ_ONLY FOR
	SELECT [Name] FROM sys.databases WHERE [Name] LIKE 'eSchoolLDB_%'

OPEN eSchoolDB_Cursor
FETCH NEXT FROM eSchoolDB_Cursor INTO @eSchoolDB
WHILE @@FETCH_STATUS = 0
	BEGIN

	SET @SqlCommand = N'USE [' + @eSchoolDB + N']' + CHAR(13) 

	SET @SqlCommand = @SqlCommand + N'Select distinct U.SystemCode as SchoolCode, U.NAME as SchoolName, DY.yearfrom, LN.Name as Level,'
			+ N' SR.RegistrationNumber, S.LastName, s.FirstName, SL.NAME as LessonName, TEP.NAME as PeriodName, GR1.TheGrade,' 
			+ N' gr1.id as GradeId, GR1.StudentRegistrationId, GR1.TeachingOrExamPeriodLessonId,  GR1.GradetypeId,' 
			+ N' GR1.CREATEDON ,	GR1.modifiedON,  case when GR1.modifiedON is null then GR1.CREATEDON else GR1.modifiedON - 360 end AS DT' 
		+ N' into #GRall'
		+ N' from School.Grade GR1'
		+ N' inner join School.Grade GR on GR.Id <> Gr1.Id and GR1.TeachingOrExamPeriodLessonId = GR.TeachingOrExamPeriodLessonId'
						+ N' and GR1.StudentRegistrationId = GR.StudentRegistrationId and GR.GradetypeId = GR1.GradetypeId'
		+ N' inner join School.StudentRegistration Sr on Sr.Id = GR1.StudentRegistrationId'
		+ N' LEFT JOIN Unit.Unit U ON Sr.SchoolId = U.ID'
		+ N' left JOIN School.Student S ON S.ID= SR.StudentId'
		+ N' left join Studies.Level L on L.Id = Sr.LevelId'
		+ N' left join Studies.LevelName LN on LN.Id = L.LevelNameId'
		+ N' left join Studies.DidacticYear DY on L.DidacticYearId = DY.Id'
		+ N' left JOIN Studies.TeachingOrExamPeriodLesson TEPL ON TEPL.ID = GR1.TeachingOrExamPeriodLessonId'
		+ N' left JOIN Studies.Lesson LS ON LS.ID = TEPL.LessonId'
		+ N' LEFT JOIN Studies.SectionLesson SL ON SL.ID = LS.SectionLessonId'
		+ N' left JOIN Studies.TeachingOrExamPeriod TEP ON TEP.ID = TEPL.TeachingOrExamPeriodId'
		+ N' order by U.SystemCode, DY.yearfrom, S.LastName, s.FirstName,'
			+ N' GR1.StudentRegistrationId, GR1.TeachingOrExamPeriodLessonId, GR1.CREATEDON' + CHAR(13)


	SET @SqlCommand = @SqlCommand + N' select StudentRegistrationId, TeachingOrExamPeriodLessonId, GradetypeId, count(*) as cnt, mIN(DT) as minDate'
		+ N' into #GRvalid'
		+ N' from #GRall'
		+ N' group by TeachingOrExamPeriodLessonId, StudentRegistrationId, GradetypeId'
		+ N' order by StudentRegistrationId, TeachingOrExamPeriodLessonId, GradetypeId' + CHAR(13)


	SET @SqlCommand = @SqlCommand + N' select #GRall.StudentRegistrationId, #GRall.TeachingOrExamPeriodLessonId, #GRall.GradetypeId,' 
				+ N' convert(uniqueidentifier, max(convert(varchar(40),#GRall.gradeId))) as gradeId'
		+ N' into #GRdel'
		+ N' from #GRall join ('
			+ N' select StudentRegistrationId, TeachingOrExamPeriodLessonId, GradetypeId , dt, count(*) as cnt' 
			+ N' from #GRall'
			+ N' group by TeachingOrExamPeriodLessonId, StudentRegistrationId, GradetypeId, dt'
			+ N' having count(*) > 1'
		+ N' ) gr1d on gr1d.TeachingOrExamPeriodLessonId = #GRall.TeachingOrExamPeriodLessonId' 
				+ N' and  gr1d.StudentRegistrationId  = #GRall.StudentRegistrationId' 
				+ N' and  gr1d.GradetypeId = #GRall.GradetypeId'
		+ N' group by #GRall.StudentRegistrationId, #GRall.TeachingOrExamPeriodLessonId, #GRall.GradetypeId'
		+ N' order by  #GRall.StudentRegistrationId, #GRall.TeachingOrExamPeriodLessonId, #GRall.GradetypeId' + CHAR(13)

	
	SET @SqlCommand = @SqlCommand + N' delete from #GRall from #GRall'
		+ N' join #GRdel on #GRall.StudentRegistrationId = #GRdel.StudentRegistrationId' 
				+ N' and #GRall.TeachingOrExamPeriodLessonId  = #GRdel.TeachingOrExamPeriodLessonId' 
				+ N' and #GRall.GradetypeId = #GRdel.GradetypeId' + CHAR(13)

	SET @SqlCommand = @SqlCommand + N' insert into #GRdel (StudentRegistrationId, TeachingOrExamPeriodLessonId, GradetypeId, GradeId)'
		+ N' select #GRall.StudentRegistrationId, #GRall.TeachingOrExamPeriodLessonId, #GRall.GradetypeId, #GRall.gradeId'
		+ N' from #GRall'
		+ N' left join #GRvalid on #GRall.StudentRegistrationId = #GRvalid.StudentRegistrationId and'  
			+ N' #GRall.TeachingOrExamPeriodLessonId = #GRvalid.TeachingOrExamPeriodLessonId  and'
			+ N' #GRall.GradetypeId = #GRvalid.GradetypeId and #GRall.DT = #GRvalid.mindate'  
		+ N' where #GRvalid.StudentRegistrationId is null' + CHAR(13)

	SET @SqlCommand = @SqlCommand + N' delete from School.Grade' 
		+ N' from School.Grade G'
		+ N' join #GRdel on G.Id = #GRdel.gradeId' 

	EXEC sp_executesql @stmt = @SqlCommand

	FETCH NEXT FROM eSchoolDB_Cursor INTO @eSchoolDB
	END
CLOSE eSchoolDB_Cursor
DEALLOCATE eSchoolDB_Cursor
